!c Description: 
!c   Ķη׻
!c
!c Current Code Owner: 
!c   sugiyama@gfd-dennou.org
!c
!c Copyright (C) SUGIYAMA Ko-ichiro, 2004, All rights reserved

subroutine BasicType(ss_CpBasicZ, ss_DensBasicZ, &
     & ss_ExnerBasicZ, ss_ThetaBasicZ, ss_VelSoundBasicZ)

  !--- ⥸塼θƤӽФ
  use gridset, only: DimXMin, DimXMax, DimZMin, DimZMax, s_Z
  use physprm, only: GasRUniv
  use arareprm,   only: Grav
  use gacchanprm, only: TempSfc, PressSfc, MolWtDry, CpDry, &
       &                TempType, PressType

  !--- ۤηػ
  implicit none

  !--- ⥸塼ѿ
  real(8), intent(out) :: ss_CpBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(out) :: ss_DensBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)  
  real(8), intent(out) :: ss_ExnerBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(out) :: ss_ThetaBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(out) :: ss_VelSoundBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)

  !--- ѿ
  real(8)  :: ss_TempBasicZ(DimXMin:DimXMax, DimZMin:DimZMax) ! ʿѲپ
  real(8)  :: ss_CvBasicZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8)  :: ss_Z(DimXMin:DimXMax, DimZMin:DimZMax)     ! 2-D ɸ
  real(8)  :: GasR
  integer  :: k


  !--- ɸ
  do k = DimZMin, DimZMax
     ss_Z(:,k) = s_Z(k)
  end do

  !--------------------------------------------
  !--- 
  !--------------------------------------------
  GasR = GasRUniv / MolWtDry
  
  
  !--------------------------------------------
  !--- Ǯ
  !---   Ǯϴ絤ǰƬ˰ͤȤ. 
  !--------------------------------------------
  ss_CpBasicZ = CpDry / MolWtDry
  ss_CvBasicZ = ss_CpBasicZ - GasR


  !--------------------------------------------
  !--- /, ̵Ϥδܾ
  !--------------------------------------------
  if (TempType == "uniform" .AND. PressType == "uniform") then 

     !--- پ TempSfc ǰ
     ss_TempBasicZ = TempSfc
     
     !--- ɽ̰Ϥǰ. ͤ 1 Ȥʤ. 
     ss_ExnerBasicZ = 1.0d0
     
     !--- 
     ss_ThetaBasicZ = ss_TempBasicZ / ss_ExnerBasicZ 
     
  elseif (TempType == "uniform" .AND. PressType == "hydrostatic") then 
     
     !--- پ TempSfc ǰ
     ss_TempBasicZ = TempSfc
     
     !--- ̵ϤȲ̤ϢΩƲ. 
     ss_ExnerBasicZ = &
          & dexp( - Grav * ss_Z / ( ss_CpBasicZ * ss_TempBasicZ ) )

     !--- ̵ϤѤƲ̤׻
     ss_ThetaBasicZ = ss_TempBasicZ / ss_ExnerBasicZ
     
  elseif (TempType == "adiabat" .AND. PressType == "uniform") then 

     !--- ɽ̤Ǥβ(= TempSfc)ǰ
     ss_ThetaBasicZ = TempSfc

     !--- ɽ̰Ϥǰ. ͤ 1 Ȥʤ. 
     ss_ExnerBasicZ = 1.0d0

  elseif (TempType == "adiabat" .AND. PressType == "hydrostatic") then 
     
     !--- ɽ̤Ǥβ(= TempSfc)ǰ
     ss_ThetaBasicZ = TempSfc

     !--- ̵Ϥ׻. ̰
     ss_ExnerBasicZ = &
          & - Grav * ss_Z / ( ss_CpBasicZ * ss_ThetaBasicZ ) + 1.0d0

  else
     write(*,*) "unknown TempType, or PressType"
     write(*,*) TempType, PressType
        
  end if

    
  !--------------------------------------------
  !---- ̩
  !--------------------------------------------
  ss_DensBasicZ = &
       & PressSfc * ( ss_ExnerBasicZ ** (ss_CvBasicZ / GasR) ) &
       &   / ( GasR * ss_ThetaBasicZ )
  
  
  !--------------------------------------------    
  !--- ʿѾβ®
  !--------------------------------------------
  ss_VelSoundBasicZ = &
       & ss_CpBasicZ * GasR * ss_ExnerBasicZ * ss_ThetaBasicZ &
       &   / ss_CvBasicZ  
  ss_VelSoundBasicZ = sqrt( ss_VelSoundBasicZ )
  
  
end subroutine BasicType

